
#pragma	sfr

#include "trgbios.h"

/*

		gWX^Zp@QOOXNU

	WindowsAvP[VETvpt@[EFA


			Copyright 2009, Yoshi Hiroshi.

 */

volatile unsigned char previousPortdValue;
volatile unsigned char commandBuff[6];
volatile unsigned char recieveLength;
volatile unsigned char sendBuff[6];
//volatile unsigned char sendLength;

volatile unsigned char portVal;

void Init();
unsigned char GetSwitch();
unsigned char RecieveCommand();
void DoCommand(unsigned char cmnd);
void CheckPortChange();

#define GET_HEX_BYTE(h) (((h) >= 0x40) ? (((h) & 0x0F) + 9) : ((h) & 0x0F))
#define GET_HEX_CHAR(h) (((h) > 9) ? ((h) + 0x41 - 10) : ((h) + 0x30))

/*---------------------------------------------
 *
 *		C[`
 *
 */
void main()
{
	unsigned char loop;
	unsigned char innerLoop1;
	unsigned char innerLoop2;
	unsigned char innerLoop3;
	Init();
	P6.1 = 1;
	P1 = 0xFF;

	if((trg_getstatus(0) & 0x10) != 0) // Not Connected
	{
		trg_usbopen();
		for(loop = 0; loop < 8; loop++)
		{
			P6.1 ^= 1;
			for(innerLoop1 = 0; innerLoop1 < 100; innerLoop1++)
			{
				for(innerLoop2 = 0; innerLoop2 < 100; innerLoop2++)
				{
					for(innerLoop3 = 0; innerLoop3 < 10; innerLoop3++)
					{
					}
				}
			}
		}
		P6.1 = 1;
	}
	
	while(1)
	{
		DoCommand(RecieveCommand());			// R}h̎M,s
		CheckPortChange();						// |[gω̃`FbN
	}
}

/*---------------------------------------------
 *
 *		
 *
 */
void Init()
{
// Init PORT
	PM6 = 0xfd;
	P1 = 0xFF;
	PM1 = 0x00;							// Port1o͂Ƃ
	PM0 |= 0x03;
	PU0 |= 0x03;
	PM3 |= 0x03;
	PU3 |= 0x03;
	PM12 |= 0x01;
	PU12 |= 0x01;

// Init Command Buffer
	recieveLength = 0;
	sendBuff[4] = 0x0D;
	sendBuff[5] = 0x0A;
	//sendLength = 0;
	previousPortdValue = 0;
}

/*---------------------------------------------
 *
 *		XBb`f[^̎擾
 *
 */
unsigned char GetSwitch()
{
	unsigned char work = 0;
	if(P12.0) work |= 0x40;
	if(P3.1) work |= 0x20;
	if(P3.0) work |= 0x10;
	if(P0.1) work |= 0x08;
	if(P0.0) work |= 0x04;
	return work;
}


/*---------------------------------------------
 *
 *		R}h̎M
 *
 */
unsigned char RecieveCommand()
{
	unsigned char result = 0;
	if( trg_getrecvcount() != 0)		// f[^MH
	{
		portVal = trg_getc();
		switch(portVal)
		{
		case 0x0D:
		case 0x0A:						// CR/LFł̓obt@
			recieveLength = 0;
			break;
		default:
			if(recieveLength < 4)		// obt@TCYȓȂA
				commandBuff[recieveLength++] = portVal;		// f[^obt@Ɋi[
			break;
		}

		switch(commandBuff[0])
		{
		case 'R':
		case 'r':
			if(recieveLength == 2) result = 'R';
			break;
		case 'W':
		case 'w':
			if(recieveLength == 4) result = 'W';
			break;
		default:
			break;
		}
	}
	return result;
}


/*---------------------------------------------
 *
 *		R}h̎s
 *
 */
void DoCommand(unsigned char cmnd)
{
	unsigned char work1, work2;
	unsigned char commandExist = 0;
	switch(cmnd)
	{
	case 'R':
	case 'r':
		if((commandBuff[1] == 'B') || (commandBuff[1] == 'b'))
		{
			portVal = ~P1;
			commandExist = 1;
		}
		if((commandBuff[1] == 'D') || (commandBuff[1] == 'd'))
		{
			portVal = GetSwitch();
			commandExist = 1;
		}
		if(commandExist != 0) 
		{
			sendBuff[0] = 'P';
			sendBuff[1] = commandBuff[1] & 0xDF;
			work1 = (portVal >> 4) & 0x0F;
			sendBuff[2] = GET_HEX_CHAR(work1);
			work2 = portVal & 0x0F;
			sendBuff[3] = GET_HEX_CHAR(work2);
			//sendBuff[4] = 0x0D;
			//sendBuff[5] = 0x0A;
			//sendLength = 6;
			trg_senddata(sendBuff, 5);
		}
		break;
	case 'W':
	case 'w':
		if((commandBuff[1] == 'B') || (commandBuff[1] == 'b'))
		{
			work1 = commandBuff[2];
			work2 = commandBuff[3];
			portVal = (GET_HEX_BYTE(work1) << 4) | GET_HEX_BYTE(work2);
			P1 = ~portVal;
		}
		break;
	default:
		break;
	}
}

/*---------------------------------------------
 *
 *		|[g̕ωo
 *
 */
void CheckPortChange()
{
	unsigned char work = GetSwitch();
	if(previousPortdValue != work)
	{
		previousPortdValue = work;
		sendBuff[0] = 'C';
		sendBuff[1] = 'D';
		work = (previousPortdValue >> 4) & 0x0F;
		sendBuff[2] = GET_HEX_CHAR(work);
		work = previousPortdValue & 0x0F;
		sendBuff[3] = GET_HEX_CHAR(work);
		//sendBuff[4] = 0x0D;
		//sendBuff[5] = 0x0A;
		//sendLength = 6;
		trg_senddata(sendBuff, 5);
	}
}


